Subject: [PATCH v3 0/1] git-add--interactive.perl: Add progress counter in the prompt

From: "Kunal Tyagi via GitGitGadget" <[email-masked]>
Date: Sun, 29 Sep 2019 22:22:58 -0700 (PDT)

Hi git contributors!

I'm Kunal Tyagi. While I was choosing the relevant patches for a commit
using the git add -p command, I found that there was no feedback regarding
how many hunks from the current file had been processed and how many were
left. So I decided to add a small change to the prompt which basically just
displays (${current-hunk-id} + 1/${total-hunks}) before displaying the
prompt during user interaction. This patch doesn't account for all total
hunks, only per file.

I don't know perl so even this one liner might have mistakes. I did test
this locally and hope this works for others. Personally, this change feels
helpful to me when I have to separate a long list of changes after an
erroneous commit.

On the #git-devel freenode channel, I was informed that @dscho is rewriting
git-add in C. If so, perhaps a similar change could be added in the rewrite.
I haven't seen his patches in detail so I can't comment if it'll be as
trivial as in perl.

Regards Kunal Tyagi

Kunal Tyagi (1):
  add -i: Show progress counter in the prompt

 git-add--interactive.perl  | 2 +-
 t/t3701-add-interactive.sh | 2 +-
 2 files changed, 2 insertions(+), 2 deletions(-)

base-commit: 4c86140027f4a0d2caaa3ab4bd8bfc5ce3c11c8a
Published-As: https://github.com/gitgitgadget/git/releases/tag/pr-349%2Fkunaltyagi%2Fmaster-v3
Fetch-It-Via: git fetch https://github.com/gitgitgadget/git pr-349/kunaltyagi/master-v3
Pull-Request: https://github.com/gitgitgadget/git/pull/349

Range-diff vs v2:

 1:  a9c5906899 ! 1:  b351c74a3f git-add--interactive.perl: Add progress counter in the prompt
     @@ -1,14 +1,10 @@
      Author: Kunal Tyagi <[email-masked]>
      
     -    git-add--interactive.perl: Add progress counter in the prompt
     +    add -i: Show progress counter in the prompt
      
     -    Adds a feedback regarding how many hunks from the current file have been
     -    processed and total number of hunks
     -    Also included: changes to the test script due to change in expected
     -    output string
     -
     -    Change in UI: displays '(${current-hunk-id} + 1/${total-hunks-in-file})' before
     -    displaying the current prompt during user interaction
     +    Report the current hunk count and total number of hunks for the current
     +    file in the prompt
     +    Adjust the expected output in some tests to account for new data on the prompt
      
          Signed-off-by: Kunal Tyagi <[email-masked]>
      
     @@ -20,7 +16,7 @@
       			print;
       		}
      -		print colored $prompt_color,
     -+		print colored $prompt_color,"(". ($ix+1) ."/$num) ",
     ++		print colored $prompt_color, "(", ($ix+1), "/$num) ",
       			sprintf(__($patch_update_prompt_modes{$patch_mode}{$hunk[$ix]{TYPE}}), $other);
       
       		my $line = prompt_single_character;
     @@ -33,7 +29,7 @@
       	git apply patch &&
       	printf "%s\n" s y y | git add -p file 2>error |
      -		sed -n -e "s/^Stage this hunk[^@]*\(@@ .*\)/\1/" \
     -+		sed -n -e "s/^(.*) Stage this hunk[^@]*\(@@ .*\)/\1/" \
     ++		sed -n -e "s/^([1-2]\/[1-2]) Stage this hunk[^@]*\(@@ .*\)/\1/" \
       		       -e "/^[-+@ \\\\]"/p  >output &&
       	test_must_be_empty error &&
       	git diff --cached >diff &&

-- 
gitgitgadget